unit ASFcnExp;

{$WARN SYMBOL_PLATFORM OFF}
{$WARN DUPLICATE_CTOR_DTOR OFF}

interface

implementation

uses
  ASExpression, ASFunctions;

procedure ExportFunctions(const Functions: array of TASFunctionClass);
begin

end;

initialization
  ExportFunctions(
    [
      FCN_ListExprNode,
      FCN_Identity,
      FCN_Add,
      FCN_Subtract,
      FCN_UnaryMinus,
      FCN_Multiply,
      FCN_InnerProduct,
      FCN_Divide,
      FCN_Power,
      FCN_Cross,
      FCN_CrossProduct,
      FCN_Angle,
      FCN_Factorial,
      FCN_Absolute,
      FCN_ConjugateTranspose,
      FCN_Transpose,
      FCN_Argument,
      FCN_RealPart,
      FCN_ImaginaryPart,
      FCN_sqrt,
      FCN_Deg,
      FCN_Percent,
      FCN_Permille,
      FCN_Square,
      FCN_sin,
      FCN_cos,
      FCN_tan,
      FCN_cot,
      FCN_sec,
      FCN_csc,
      FCN_arcsin,
      FCN_arccos,
      FCN_arctan,
      FCN_arccot,
      FCN_arcsec,
      FCN_arccsc,
      FCN_sinh,
      FCN_cosh,
      FCN_tanh,
      FCN_coth,
      FCN_sech,
      FCN_csch,
      FCN_arcsinh,
      FCN_arccosh,
      FCN_arctanh,
      FCN_arccoth,
      FCN_arcsech,
      FCN_arccsch,
      FCN_sinc,
      FCN_exp,
      FCN_ln,
      FCN_log,
      FCN_floor,
      FCN_ceil,
      FCN_round,
      FCN_trunc,
      FCN_frac,
      FCN_sgn,
      FCN_mod,
      FCN_lcm,
      FCN_gcd,
      FCN_combinations,
      FCN_permutations,
      FCN_IsPrime,
      FCN_NextPrime,
      FCN_PrevPrime,
      FCN_NthPrime,
      FCN_PrimePi,
      FCN_Fibonacci,
      FCN_Lucas,
      FCN_MbiusMu,
      FCN_Mertens,
      FCN_AreCoprime,
      FCN_Iverson,
      FCN_Kronecker,
      FCN_LegendreSymbol,
      FCN_JacobiSymbol,
      FCN_KroneckerSymbol,
      FCN_totient,
      FCN_cototient,
      FCN_PrimeFactors,
      FCN_Radical,
      FCN_IsSquareFree,
      FCN_Factorize,
      FCN_FactorizedExpression,
      FCN_Divisors,
      FCN_ContinuedFraction,
      FCN_ToFraction,
      FCN_ToSymbolicForm,
      FCN_erf,
      FCN_erfc,
      FCN_FresnelC,
      FCN_FresnelS,
      FCN_Si,
      FCN_Ci,
      FCN_Bessel,
      FCN_Laguerre,
      FCN_Hermite,
      FCN_Legendre,
      FCN_GammaFunction,
      FCN_Chebyshev,
      FCN_Bernstein,
      FCN_HarmonicNumber,
      FCN_And,
      FCN_Or,
      FCN_Not,
      FCN_Xor,
      FCN_Nand,
      FCN_Nor,
      FCN_ImpliesRight,
      FCN_ImpliesLeft,
      FCN_Equivalent,
      FCN_Equals,
      FCN_NotEquals,
      FCN_LessThan,
      FCN_LessThanOrEqualTo,
      FCN_GreaterThan,
      FCN_GreaterThanOrEqualTo,
      FCN_dim,
      FCN_size,
      FCN_width,
      FCN_height,
      FCN_Subscript,
      FCN_AccessMember,
      FCN_Norm,
      FCN_NormSquared,
      FCN_Normalized,
      FCN_First,
      FCN_Last,
      FCN_Part,
      FCN_Range,
      FCN_Sort,
      FCN_CustomSort,
      FCN_Shuffle,
      FCN_Reverse,
      FCN_Unique,
      FCN_AdjUnique,
      FCN_Frequencies,
      FCN_CollapseSequences,
      FCN_ZeroVector,
      FCN_ComplexZeroVector,
      FCN_RandomVector,
      FCN_RandomIntVector,
      FCN_RandomSignedVector,
      FCN_BasisVector,
      FCN_SequenceVector,
      FCN_SequenceList,
      FCN_ClosedInterval,
      FCN_OpenInterval,
      FCN_Random,
      FCN_RandomInt,
      FCN_RandomReal,
      FCN_SetRandomSeed,
      FCN_Randomize,
      FCN_Sum,
      FCN_Product,
      FCN_Min,
      FCN_Max,
      FCN_ArithmeticMean,
      FCN_GeometricMean,
      FCN_HarmonicMean,
      FCN_Count,
      FCN_Contains,
      FCN_Exists,
      FCN_ExistsUnique,
      FCN_ForAll,
      FCN_IndicesOf,
      FCN_Filter,
      FCN_Pick,
      FCN_PickRecursive,
      FCN_Apply,
      FCN_ApplyIf,
      FCN_ReplaceAll,
      FCN_ReplaceIf,
      FCN_ReplaceEvery,
      FCN_RemoveAll,
      FCN_RemoveIf,
      FCN_RealNumber,
      FCN_ComplexNumber,
      FCN_Number,
      FCN_Integer,
      FCN_String,
      FCN_RealVector,
      FCN_ComplexVector,
      FCN_Vector,
      FCN_RealMatrix,
      FCN_ComplexMatrix,
      FCN_Matrix,
      FCN_Boolean,
      FCN_ToList,
      FCN_ToSet,
      FCN_ToTable,
      FCN_BinaryData,
      FCN_MatrixFromCols,
      FCN_MatrixFromRows,
      FCN_MatrixFromBlocks,
      FCN_List,
      FCN_Set,
      FCN_Union,
      FCN_Intersection,
      FCN_SetDifference,
      FCN_SymDiff,
      FCN_Complement,
      FCN_ElementOf,
      FCN_NotElementOf,
      FCN_ContainsAsElement,
      FCN_NotContainsAsElement,
      FCN_Subset,
      FCN_ProperSubset,
      FCN_Superset,
      FCN_ProperSuperset,
      FCN_TypeName,
      FCN_ClassTypeData,
      FCN_ClassTypeName,
      FCN_HasComplexType,
      FCN_IsObjectContainer,
      FCN_IsValueContainer,
      FCN_IsPlanarContainer,
      FCN_IsOrderedContainer,
      FCN_Beep,
      FCN_Wait,
      FCN_GetTickCount,
      FCN_Heaviside,
      FCN_Ramp,
      FCN_Rect,
      FCN_Tri,
      FCN_GetProperty,
      FCN_Integrate,
      FCN_Differentiate,
      FCN_Length,
      FCN_Pos,
      FCN_StringContains,
      FCN_SubstringCount,
      FCN_SubstringIndices,
      FCN_StringReplace,
      FCN_Split,
      FCN_Join,
      FCN_UpperCase,
      FCN_LowerCase,
      FCN_InvertCase,
      FCN_TitleCase,
      FCN_SentenceCase,
      FCN_ROT13,
      FCN_Caesar,
      FCN_Vigenre,
      FCN_VigenreDecode,
      FCN_Trim,
      FCN_TrimLeft,
      FCN_TrimRight,
      FCN_Pad,
      FCN_Format,
      FCN_IndexOf,
      FCN_ChrIsLetter,
      FCN_ChrIsDigit,
      FCN_ChrIsLetterOrDigit,
      FCN_ChrIsNumber,
      FCN_ChrIsPunctuation,
      FCN_ChrIsSeparator,
      FCN_ChrIsWhitespace,
      FCN_ChrIsUpperCase,
      FCN_ChrIsLowerCase,
      FCN_ChrIsSymbol,
      FCN_ChrIsASCII,
      FCN_ChrIsControl,
      FCN_ChrName,
      FCN_ChrBlock,
      FCN_ListChrBlocks,
      FCN_ChrBlockRange,
      FCN_Character,
      FCN_ChrCode,
      FCN_ChrNumVal,
      FCN_Odd,
      FCN_Even,
      FCN_Date,
      FCN_Time,
      FCN_Now,
      FCN_DateTime,
      FCN_AddMilliseconds,
      FCN_AddSeconds,
      FCN_AddMinutes,
      FCN_AddHours,
      FCN_AddDays,
      FCN_AddWeeks,
      FCN_AddMonths,
      FCN_AddYears,
      FCN_DateValid,
      FCN_TimeValid,
      FCN_DateTimeValid,
      FCN_MillisecondsBetween,
      FCN_SecondsBetween,
      FCN_MinutesBetween,
      FCN_HoursBetween,
      FCN_DaysBetween,
      FCN_WeeksBetween,
      FCN_MonthsBetween,
      FCN_YearsBetween,
      FCN_DayOfTheWeek,
      FCN_DayOfTheMonth,
      FCN_DayOfTheYear,
      FCN_WeekOfTheYear,
      FCN_SecondOfTheDay,
      FCN_SecondOfTheWeek,
      FCN_SecondOfTheMonth,
      FCN_SecondOfTheYear,
      FCN_MillisecondOfTheDay,
      FCN_MillisecondOfTheWeek,
      FCN_MillisecondOfTheMonth,
      FCN_MillisecondOfTheYear,
      FCN_IsLeapYear,
      FCN_DaysInYear,
      FCN_DaysInMonth,
      FCN_Timestamp,
      FCN_Today,
      FCN_Tomorrow,
      FCN_Yesterday,
      FCN_TruncateToMillisecond,
      FCN_TruncateToSecond,
      FCN_TruncateToMinute,
      FCN_TruncateToHour,
      FCN_TruncateToDay,
      FCN_TruncateToMonth,
      FCN_TruncateToYear,
      FCN_NumDigits,
      FCN_MinLength,
      FCN_NumberFormat,
      FCN_NumberBase,
      FCN_FormatStyle,
      FCN_DigitGrouping,
      FCN_PrettyExp,
      FCN_MaxLen,
      FCN_SetNumDigits,
      FCN_SetMinLength,
      FCN_SetNumberFormat,
      FCN_SetNumberBase,
      FCN_SetFormatStyle,
      FCN_SetDigitGrouping,
      FCN_SetPrettyExp,
      FCN_SetMaxLen,
      FCN_AsSingleLine,
      FCN_InputForm,
      FCN_AsMultiLine,
      FCN_SaveToFile,
      FCN_LoadFromFile,
      FCN_CopyToClipboard,
      FCN_Flatten,
      FCN_Group,
      FCN_Variable,
      FCN_Object,
      FCN_Metadata,
      FCN_Description,
      FCN_Delete,
      FCN_Protect,
      FCN_Unprotect,
      FCN_Assign,
      FCN_Cls,
      FCN_Exit,
      FCN_Fail,
      FCN_Assert,
      FCN_Succeeded,
      FCN_Try,
      FCN_Piecewise,
      FCN_MakeMember,
      FCN_MakeStruct,
      FCN_System,
      FCN_RotLeft,
      FCN_RotRight,
      FCN_Diag,
      FCN_Row,
      FCN_Col,
      FCN_Rows,
      FCN_Cols,
      FCN_MainDiagonal,
      FCN_Superdiagonal,
      FCN_Subdiagonal,
      FCN_Antidiagonal,
      FCN_ReplaceRow,
      FCN_ReplaceCol,
      FCN_ReplaceDiagonal,
      FCN_ReplaceSuperdiagonal,
      FCN_ReplaceSubdiagonal,
      FCN_ReplaceAntidiagonal,
      FCN_IsRow,
      FCN_IsCol,
      FCN_IsSquare,
      FCN_IsIdentity,
      FCN_IsZeroMatrix,
      FCN_IsDiagonal,
      FCN_IsAntiDiagonal,
      FCN_IsReversal,
      FCN_IsUpperTriangular,
      FCN_IsLowerTriangular,
      FCN_IsTriangular,
      FCN_IsRowEchelonForm,
      FCN_IsReducedRowEchelonForm,
      FCN_IsScalar,
      FCN_IsSymmetric,
      FCN_IsSkewSymmetric,
      FCN_IsHermitian,
      FCN_IsSkewHermitian,
      FCN_IsOrthogonal,
      FCN_IsUnitary,
      FCN_IsNormal,
      FCN_IsBinary,
      FCN_IsPermutation,
      FCN_IsCirculant,
      FCN_IsToeplitz,
      FCN_IsHankel,
      FCN_IsUpperHessenberg,
      FCN_IsLowerHessenberg,
      FCN_IsTridiagonal,
      FCN_IsUpperBidiagonal,
      FCN_IsLowerBidiagonal,
      FCN_IsBidiagonal,
      FCN_IsCentrosymmetric,
      FCN_IsVandermonde,
      FCN_IsIdempotent,
      FCN_IsInvolution,
      FCN_IsPositiveDefinite,
      FCN_IsPositiveSemidefinite,
      FCN_IsNegativeDefinite,
      FCN_IsNegativeSemidefinite,
      FCN_IsIndefinite,
      FCN_IsNilpotent,
      FCN_NilpotencyIndex,
      FCN_IsPositive,
      FCN_IsNonNegative,
      FCN_IsNegative,
      FCN_IsNonPositive,
      FCN_IsZero,
      FCN_IsNonZero,
      FCN_PivotPos,
      FCN_IsZeroRow,
      FCN_IsEssentiallyZeroRow,
      FCN_IsDiagonallyDominant,
      FCN_IsStrictlyDiagonallyDominant,
      FCN_CommutesWith,
      FCN_ToLowerTriangular,
      FCN_ToUpperTriangular,
      FCN_ToUpperHessenberg,
      FCN_HermitianSquare,
      FCN_Modulus,
      FCN_Determinant,
      FCN_Trace,
      FCN_Inverse,
      FCN_Rank,
      FCN_Nullity,
      FCN_ConditionNumber,
      FCN_IsSingular,
      FCN_DeletedAbsoluteRowSum,
      FCN_RowSwap,
      FCN_RowScale,
      FCN_RowAddMul,
      FCN_RowEchelonForm,
      FCN_ReducedRowEchelonForm,
      FCN_NumZeroRows,
      FCN_NumTrailingZeroRows,
      FCN_GramSchmidt,
      FCN_ColumnSpaceBasis,
      FCN_ColumnSpaceProjection,
      FCN_DistanceFromColumnSpace,
      FCN_Eigenvalues,
      FCN_Spectrum,
      FCN_Eigenvectors,
      FCN_IsEigenvector,
      FCN_EigenvalueOf,
      FCN_IsEigenpair,
      FCN_EigenvectorOf,
      FCN_SpectralRadius,
      FCN_SingularValues,
      FCN_Defuzz,
      FCN_Vectorization,
      FCN_Aug,
      FCN_SubmatrixByRemoval,
      FCN_LeadingPrincipalSubmatrix,
      FCN_Lessen,
      FCN_Minor,
      FCN_Cofactor,
      FCN_CofactorMatrix,
      FCN_AdjugateMatrix,
      FCN_LU,
      FCN_Cholesky,
      FCN_QR,
      FCN_Hessenberg,
      FCN_SameValue,
      FCN_CompareValue,
      FCN_ZeroMatrix,
      FCN_ComplexZeroMatrix,
      FCN_IdentityMatrix,
      FCN_ReversalMatrix,
      FCN_RandomMatrix,
      FCN_RandomIntMatrix,
      FCN_OuterProduct,
      FCN_CirculantMatrix,
      FCN_ToeplitzMatrix,
      FCN_HankelMatrix,
      FCN_BackwardShiftMatrix,
      FCN_ForwardShiftMatrix,
      FCN_VandermondeMatrix,
      FCN_HilbertMatrix,
      FCN_RotationMatrix,
      FCN_ReflectionMatrix,
      FCN_HadamardProduct,
      FCN_DirectSum,
      FCN_ForwardSubstitution,
      FCN_BackSubstitution,
      FCN_SysSolve,
      FCN_LeastSquaresPolynomialFit,
      FCN_AreParallel,
      FCN_AreNotParallel,
      FCN_ArePerpendicular,
      FCN_RGBValues,
      FCN_HSVValues,
      FCN_HSLValues,
      FCN_Color,
      FCN_HexColorCode,
      FCN_GetNamedColors,
      FCN_IsDark,
      FCN_RGB,
      FCN_HSV,
      FCN_HSL,
      FCN_AddMember,
      FCN_RemoveMember,
      FCN_SetValue,
      FCN_RenameMember,
      FCN_HasMember,
      FCN_IndexOfName,
      FCN_ToStructType,
      FCN_New,
      FCN_StructType,
      FCN_RegisterStructType,
      FCN_UnregisterStructType,
      FCN_ValidateStruct,
      FCN_CreatePixmap,
      FCN_AddBorder,
      FCN_ExtendBorder,
      FCN_ColorFrequencies,
      FCN_ColorCount,
      FCN_FillRect,
      FCN_DrawRect,
      FCN_AlphaDrawRect,
      FCN_FixHue,
      FCN_ToMonochromatic,
      FCN_ShiftHue,
      FCN_ToGreyscale,
      FCN_InvertColor,
      FCN_InvertValue,
      FCN_InvertLightness,
      FCN_RGBAdjustment,
      FCN_HSVAdjustment,
      FCN_Binarize,
      FCN_Flip,
      FCN_Rot90P,
      FCN_Rot90N,
      FCN_Rot180,
      FCN_ScanlineRotation,
      FCN_CustomScanlineRotation,
      FCN_SkewRotation,
      FCN_Scale,
      FCN_Stretch,
      FCN_Rotate,
      FCN_Shear,
      FCN_ApplyLinearTransformation,
      FCN_ApplyTransformation,
      FCN_GetRect,
      FCN_AverageColor,
      FCN_GetAutoCropRect,
      FCN_AutoCrop,
      FCN_ExpandCanvas,
      FCN_OnlyBackground,
      FCN_DetectEdges,
      FCN_Emboss,
      FCN_Pixellate,
      FCN_Noise,
      FCN_DistortMetric,
      FCN_DistortColor,
      FCN_Tiles,
      FCN_ComponentHighlight,
      FCN_FloodFill,
      FCN_DrawLine,
      FCN_DrawLines,
      FCN_DrawPolygon,
      FCN_Convolve,
      FCN_ConvolutionKernel,
      FCN_MotionBlur,
      FCN_BoxBlur,
      FCN_GaussianBlur,
      FCN_Darken,
      FCN_Whiten,
      FCN_FadeToColor,
      FCN_EveryOtherToColor,
      FCN_RandomToColor,
      FCN_Wind,
      FCN_RandomScanlineRotation,
      FCN_Ripple,
      FCN_ExtractChannel,
      FCN_CombineChannels,
      FCN_IsGreyscale,
      FCN_DrawDisk,
      FCN_DrawDisks,
      FCN_DrawSquare,
      FCN_DrawSquares,
      FCN_CreateGradient,
      FCN_Voronoi,
      FCN_SuperposeSounds,
      FCN_AppendSound,
      FCN_EchoSound,
      FCN_SoundScaleAmplitude,
      FCN_SoundConvertTo,
      FCN_SineTone,
      FCN_WhiteNoise,
      FCN_MultichannelSound,
      FCN_FadeSounds,
      FCN_ComputeSound,
      FCN_SoundMetadata,
      FCN_SoundMax,
      FCN_PlaySound,
      FCN_StopSound,
      FCN_SetInstrument,
      FCN_GetInstrument,
      FCN_SetVolume,
      FCN_GetVolume,
      FCN_NoteOn,
      FCN_NoteOff,
      FCN_PNoteOn,
      FCN_PNoteOff,
      FCN_NoteSilence,
      FCN_NoteReset,
      FCN_InstrumentInfo,
      FCN_PInstrumentInfo,
      FCN_NoteName,
      FCN_MidiMsg,
      FCN_LabelList,
      FCN_VarAppend,
      FCN_VarExtendWith,
      FCN_catenate,
      FCN_VarInsert,
      FCN_VarRemove,
      FCN_VarTruncate,
      FCN_VarSwap,
      FCN_Numbers,
      FCN_CreateFunction,
      FCN_Image,
      FCN_IteratedImage,
      FCN_IteratedImages,
      FCN_Orbit,
      FCN_IsNumber,
      FCN_IsVector,
      FCN_IsMatrix,
      FCN_IsText,
      FCN_IsBoolean,
      FCN_IsPixmap,
      FCN_IsSound,
      FCN_IsTable,
      FCN_IsColor,
      FCN_IsSet,
      FCN_IsList,
      FCN_IsStructure,
      FCN_IsReal,
      FCN_IsComplex,
      FCN_IsInteger,
      FCN_IsNumericEntity,
      FCN_IsNumericArray,
      FCN_IsBinaryData,
      FCN_entrywise,
      FCN_Accumulate,
      FCN_AccumulateList,
      FCN_AccumulateSteps,
      FCN_Rest,
      FCN_Append,
      FCN_ExtendWith,
      FCN_Insert,
      FCN_Remove,
      FCN_Truncate,
      FCN_Swap,
      FCN_SortBy,
      FCN_Member,
      FCN_GroupBy,
      FCN_Characters,
      FCN_Words,
      FCN_Do,
      FCN_Divides,
      FCN_NotDivides,
      FCN_Primorial,
      FCN_Inc,
      FCN_Dec,
      FCN_Variables,
      FCN_LastError,
      FCN_Functions,
      FCN_Function,
      FCN_Categories,
      FCN_FcnName,
      FCN_FcnNames,
      FCN_ErrorInfo,
      FCN_Succ,
      FCN_Pred,
      FCN_LoadDefVars,
      FCN_Operators,
      FCN_If,
      FCN_ForEach,
      FCN_Print,
      FCN_RemoveBuffer,
      FCN_BufferText,
      FCN_Buffers,
      FCN_MessageBox,
      FCN_InputBox,
      FCN_FormatDateTime,
      FCN_DateTimeString,
      FCN_DateString,
      FCN_TimeString,
      FCN_While,
      FCN_Until,
      FCN_Repeat,
      FCN_For,
      FCN_Tokenize,
      FCN_Parse,
      FCN_WordWrap,
      FCN_History,
      FCN_Input,
      FCN_Inputs,
      FCN_Output,
      FCN_HistoryLength,
      FCN_ClearHistory,
      FCN_SaveHistory,
      FCN_SelfTest,
      FCN_Bases,
      FCN_FcnExpr,
      FCN_RandomColor,
      FCN_Compute,
      FCN_DebugObject,
      FCN_CompareString,
      FCN_IsCharacter,
      FCN_IsRealType,
      FCN_IsComplexType,
      FCN_Break,
      FCN_Continue,
      FCN_SquareWave,
      FCN_TriangleWave,
      FCN_SawtoothWave,
      FCN_BlendModes,
      FCN_Display,
      FCN_Window,
      FCN_ComputePixmap,
      FCN_ColorDialog,
      FCN_FontDialog,
      FCN_FileExists,
      FCN_FileSize,
      FCN_FileName,
      FCN_PrettyFileName,
      FCN_FilePath,
      FCN_FileExt,
      FCN_DeleteFile,
      FCN_CreateDirectory,
      FCN_DeleteDirectory,
      FCN_DirectoryExists,
      FCN_FileList,
      FCN_DirectoryList,
      FCN_FileOpenDialog,
      FCN_FileSaveDialog,
      FCN_IsCarolNumber,
      FCN_StructKeys,
      FCN_Digits,
      FCN_FractionParts,
      FCN_ExampleData,
      FCN_LeftAlign,
      FCN_RightAlign,
      FCN_CenterText,
      FCN_MatrixPlot,
      FCN_Diagram,
      FCN_Scene,
      FCN_BarChart,
      FCN_PieChart,
      FCN_Histogram,
      FCN_ScatterPlot,
      FCN_LineChart,
      FCN_AreaChart,
      FCN_Graph,
      FCN_Plot,
      FCN_Heatmap,
      FCN_VectorField,
      FCN_RemoveVisual,
      FCN_AdjustVisual,
      FCN_LineSegment,
      FCN_Rectangle,
      FCN_Circle,
      FCN_Disk,
      FCN_Polygon,
      FCN_Text,
      FCN_EmbedPixmap,
      FCN_Speak,
      FCN_Surface,
      FCN_Curve,
      FCN_Sphere,
      FCN_Ellipsoid,
      FCN_Cylinder,
      FCN_Cone,
      FCN_Plane,
      FCN_InfinatePlane,
      FCN_Disk3D,
      FCN_Solid,
      FCN_Model,
      FCN_CoordinateAxes,
      FCN_Clamp,
      FCN_Paste,
      FCN_ClearScene,
      FCN_ClearDiagram,
      FCN_VisualObject,
      FCN_VisualObjects,
      FCN_MemoryUsage,
      FCN_Arrow
    ]
  );

end.
